Index: G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c
===================================================================
--- G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(revision 1)
+++ G:/DOC/Components/Atmel/AVR_ISP/avrdude/src/config_gram.c	(working copy)
@@ -765,278 +1379,254 @@
      so that they stay on the same level as the state stack.
      The wasted elements are never initialized.  */
 
-  yyssp = yyss - 1;
+  yyssp = yyss;
   yyvsp = yyvs;
-#ifdef YYLSP_NEEDED
-  yylsp = yyls;
-#endif
 
-/* Push a new state, which is found in  yystate  .  */
-/* In all cases, when you get here, the value and location stacks
-   have just been pushed. so pushing a state here evens the stacks.  */
-yynewstate:
+  goto yysetstate;
 
-  *++yyssp = yystate;
+/*------------------------------------------------------------.
+| yynewstate -- Push a new state, which is found in yystate.  |
+`------------------------------------------------------------*/
+ yynewstate:
+  /* In all cases, when you get here, the value and location stacks
+     have just been pushed. so pushing a state here evens the stacks.
+     */
+  yyssp++;
 
-  if (yyssp >= yyss + yystacksize - 1)
+ yysetstate:
+  *yyssp = yystate;
+
+  if (yyss + yystacksize - 1 <= yyssp)
     {
-      /* Give user a chance to reallocate the stack */
-      /* Use copies of these so that the &'s don't force the real ones into memory. */
-      YYSTYPE *yyvs1 = yyvs;
-      short *yyss1 = yyss;
-#ifdef YYLSP_NEEDED
-      YYLTYPE *yyls1 = yyls;
-#endif
-
       /* Get the current used size of the three stacks, in elements.  */
-      int size = yyssp - yyss + 1;
+      YYSIZE_T yysize = yyssp - yyss + 1;
 
 #ifdef yyoverflow
-      /* Each stack pointer address is followed by the size of
-	 the data in use in that stack, in bytes.  */
-#ifdef YYLSP_NEEDED
-      /* This used to be a conditional around just the two extra args,
-	 but that might be undefined if yyoverflow is a macro.  */
-      yyoverflow("parser stack overflow",
-		 &yyss1, size * sizeof (*yyssp),
-		 &yyvs1, size * sizeof (*yyvsp),
-		 &yyls1, size * sizeof (*yylsp),
-		 &yystacksize);
-#else
-      yyoverflow("parser stack overflow",
-		 &yyss1, size * sizeof (*yyssp),
-		 &yyvs1, size * sizeof (*yyvsp),
-		 &yystacksize);
-#endif
+      {
+	/* Give user a chance to reallocate the stack. Use copies of
+	   these so that the &'s don't force the real ones into
+	   memory.  */
+	YYSTYPE *yyvs1 = yyvs;
+	short int *yyss1 = yyss;
 
-      yyss = yyss1; yyvs = yyvs1;
-#ifdef YYLSP_NEEDED
-      yyls = yyls1;
-#endif
+
+	/* Each stack pointer address is followed by the size of the
+	   data in use in that stack, in bytes.  This used to be a
+	   conditional around just the two extra args, but that might
+	   be undefined if yyoverflow is a macro.  */
+	yyoverflow (YY_("memory exhausted"),
+		    &yyss1, yysize * sizeof (*yyssp),
+		    &yyvs1, yysize * sizeof (*yyvsp),
+
+		    &yystacksize);
+
+	yyss = yyss1;
+	yyvs = yyvs1;
+      }
 #else /* no yyoverflow */
+# ifndef YYSTACK_RELOCATE
+      goto yyexhaustedlab;
+# else
       /* Extend the stack our own way.  */
-      if (yystacksize >= YYMAXDEPTH)
-	{
-	  yyerror("parser stack overflow");
-	  if (yyfree_stacks)
-	    {
-	      free (yyss);
-	      free (yyvs);
-#ifdef YYLSP_NEEDED
-	      free (yyls);
-#endif
-	    }
-	  return 2;
-	}
+      if (YYMAXDEPTH <= yystacksize)
+	goto yyexhaustedlab;
       yystacksize *= 2;
-      if (yystacksize > YYMAXDEPTH)
+      if (YYMAXDEPTH < yystacksize)
 	yystacksize = YYMAXDEPTH;
-#ifndef YYSTACK_USE_ALLOCA
-      yyfree_stacks = 1;
-#endif
-      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
-      __yy_memcpy ((char *)yyss, (char *)yyss1,
-		   size * (unsigned int) sizeof (*yyssp));
-      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
-      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
-		   size * (unsigned int) sizeof (*yyvsp));
-#ifdef YYLSP_NEEDED
-      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
-      __yy_memcpy ((char *)yyls, (char *)yyls1,
-		   size * (unsigned int) sizeof (*yylsp));
-#endif
+
+      {
+	short int *yyss1 = yyss;
+	union yyalloc *yyptr =
+	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
+	if (! yyptr)
+	  goto yyexhaustedlab;
+	YYSTACK_RELOCATE (yyss);
+	YYSTACK_RELOCATE (yyvs);
+
+#  undef YYSTACK_RELOCATE
+	if (yyss1 != yyssa)
+	  YYSTACK_FREE (yyss1);
+      }
+# endif
 #endif /* no yyoverflow */
 
-      yyssp = yyss + size - 1;
-      yyvsp = yyvs + size - 1;
-#ifdef YYLSP_NEEDED
-      yylsp = yyls + size - 1;
-#endif
+      yyssp = yyss + yysize - 1;
+      yyvsp = yyvs + yysize - 1;
 
-#if YYDEBUG != 0
-      if (yydebug)
-	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
-#endif
 
-      if (yyssp >= yyss + yystacksize - 1)
+      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
+		  (unsigned long int) yystacksize));
+
+      if (yyss + yystacksize - 1 <= yyssp)
 	YYABORT;
     }
 
-#if YYDEBUG != 0
-  if (yydebug)
-    fprintf(stderr, "Entering state %d\n", yystate);
-#endif
+  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
 
   goto yybackup;
- yybackup:
 
+/*-----------.
+| yybackup.  |
+`-----------*/
+yybackup:
+
 /* Do appropriate processing given the current state.  */
-/* Read a lookahead token if we need one and don't already have one.  */
+/* Read a look-ahead token if we need one and don't already have one.  */
 /* yyresume: */
 
-  /* First try to decide what to do without reference to lookahead token.  */
+  /* First try to decide what to do without reference to look-ahead token.  */
 
   yyn = yypact[yystate];
-  if (yyn == YYFLAG)
+  if (yyn == YYPACT_NINF)
     goto yydefault;
 
-  /* Not known => get a lookahead token if don't already have one.  */
+  /* Not known => get a look-ahead token if don't already have one.  */
 
-  /* yychar is either YYEMPTY or YYEOF
-     or a valid token in external form.  */
-
+  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
   if (yychar == YYEMPTY)
     {
-#if YYDEBUG != 0
-      if (yydebug)
-	fprintf(stderr, "Reading a token: ");
-#endif
+      YYDPRINTF ((stderr, "Reading a token: "));
       yychar = YYLEX;
     }
 
-  /* Convert token to internal form (in yychar1) for indexing tables with */
-
-  if (yychar <= 0)		/* This means end of input. */
+  if (yychar <= YYEOF)
     {
-      yychar1 = 0;
-      yychar = YYEOF;		/* Don't call YYLEX any more */
-
-#if YYDEBUG != 0
-      if (yydebug)
-	fprintf(stderr, "Now at end of input.\n");
-#endif
+      yychar = yytoken = YYEOF;
+      YYDPRINTF ((stderr, "Now at end of input.\n"));
     }
   else
     {
-      yychar1 = YYTRANSLATE(yychar);
-
-#if YYDEBUG != 0
-      if (yydebug)
-	{
-	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
-	  /* Give the individual parser a way to print the precise meaning
-	     of a token, for further debugging info.  */
-#ifdef YYPRINT
-	  YYPRINT (stderr, yychar, yylval);
-#endif
-	  fprintf (stderr, ")\n");
-	}
-#endif
+      yytoken = YYTRANSLATE (yychar);
+      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
     }
 
-  yyn += yychar1;
-  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
+  /* If the proper action on seeing token YYTOKEN is to reduce or to
+     detect an error, take that action.  */
+  yyn += yytoken;
+  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
     goto yydefault;
-
   yyn = yytable[yyn];
-
-  /* yyn is what to do for this token type in this state.
-     Negative => reduce, -yyn is rule number.
-     Positive => shift, yyn is new state.
-       New state is final state => don't bother to shift,
-       just return success.
-     0, or most negative number => error.  */
-
-  if (yyn < 0)
+  if (yyn <= 0)
     {
-      if (yyn == YYFLAG)
+      if (yyn == 0 || yyn == YYTABLE_NINF)
 	goto yyerrlab;
       yyn = -yyn;
       goto yyreduce;
     }
-  else if (yyn == 0)
-    goto yyerrlab;
 
   if (yyn == YYFINAL)
     YYACCEPT;
 
-  /* Shift the lookahead token.  */
+  /* Shift the look-ahead token.  */
+  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
 
-#if YYDEBUG != 0
-  if (yydebug)
-    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
-#endif
-
   /* Discard the token being shifted unless it is eof.  */
   if (yychar != YYEOF)
     yychar = YYEMPTY;
 
   *++yyvsp = yylval;
-#ifdef YYLSP_NEEDED
-  *++yylsp = yylloc;
-#endif
 
-  /* count tokens shifted since error; after three, turn off error status.  */
-  if (yyerrstatus) yyerrstatus--;
 
+  /* Count tokens shifted since error; after three, turn off error
+     status.  */
+  if (yyerrstatus)
+    yyerrstatus--;
+
   yystate = yyn;
   goto yynewstate;
 
-/* Do the default action for the current state.  */
+
+/*-----------------------------------------------------------.
+| yydefault -- do the default action for the current state.  |
+`-----------------------------------------------------------*/
 yydefault:
-
   yyn = yydefact[yystate];
   if (yyn == 0)
     goto yyerrlab;
+  goto yyreduce;
 
-/* Do a reduction.  yyn is the number of a rule to reduce with.  */
+
+/*-----------------------------.
+| yyreduce -- Do a reduction.  |
+`-----------------------------*/
 yyreduce:
+  /* yyn is the number of a rule to reduce with.  */
   yylen = yyr2[yyn];
-  if (yylen > 0)
-    yyval = yyvsp[1-yylen]; /* implement default value of the action */
 
-#if YYDEBUG != 0
-  if (yydebug)
+  /* If YYLEN is nonzero, implement the default value of the action:
+     `$$ = $1'.
+
+     Otherwise, the following line sets YYVAL to garbage.
+     This behavior is undocumented and Bison
+     users should not rely upon it.  Assigning to YYVAL
+     unconditionally makes the parser a bit smaller, and it avoids a
+     GCC warning that YYVAL may be used uninitialized.  */
+  yyval = yyvsp[1-yylen];
+
+
+  YY_REDUCE_PRINT (yyn);
+  switch (yyn)
     {
-      int i;
+        case 8:
+#line 191 "../config_gram.y"
+    {
+    strncpy(default_programmer, (yyvsp[-1])->value.string, MAX_STR_CONST);
+    default_programmer[MAX_STR_CONST-1] = 0;
+    free_token((yyvsp[-1]));
+  }
+    break;
 
-      fprintf (stderr, "Reducing via rule %d (line %d), ",
-	       yyn, yyrline[yyn]);
+  case 9:
+#line 197 "../config_gram.y"
+    {
+    strncpy(default_parallel, (yyvsp[-1])->value.string, PATH_MAX);
+    default_parallel[PATH_MAX-1] = 0;
+    free_token((yyvsp[-1]));
+  }
+    break;
 
-      /* Print the symbols being reduced, and their result.  */
-      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
-	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
-      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
-    }
-#endif
+  case 10:
+#line 203 "../config_gram.y"
+    {
+    strncpy(default_serial, (yyvsp[-1])->value.string, PATH_MAX);
+    default_serial[PATH_MAX-1] = 0;
+    free_token((yyvsp[-1]));
+  }
+    break;
 
+  case 11:
+#line 208 "../config_gram.y"
+    {
+  	FastWrite = (yyvsp[-1])->value.number;
+  	if (FastWrite != 0) {
+  		fprintf(stderr,"use fast write by default\n");
+  	}
+    free_token((yyvsp[-1]));
+  }
+    break;
 
-  switch (yyn) {
+  case 12:
+#line 216 "../config_gram.y"
+    {
+  	FastVerify = (yyvsp[-1])->value.number;
+  	if (FastVerify != 0) {
+  		fprintf(stderr,"use fast verify by default\n");
+  	}
+    free_token((yyvsp[-1]));
+  }
+    break;
 
-case 7:
-#line 188 "../config_gram.y"
-{
-    strncpy(default_programmer, yyvsp[-1]->value.string, MAX_STR_CONST);
-    default_programmer[MAX_STR_CONST-1] = 0;
-    free_token(yyvsp[-1]);
-  ;
-    break;}
-case 8:
-#line 194 "../config_gram.y"
-{
-    strncpy(default_parallel, yyvsp[-1]->value.string, PATH_MAX);
-    default_parallel[PATH_MAX-1] = 0;
-    free_token(yyvsp[-1]);
-  ;
-    break;}
-case 9:
-#line 200 "../config_gram.y"
-{
-    strncpy(default_serial, yyvsp[-1]->value.string, PATH_MAX);
-    default_serial[PATH_MAX-1] = 0;
-    free_token(yyvsp[-1]);
-  ;
-    break;}
-case 10:
-#line 210 "../config_gram.y"
-{ current_prog = pgm_new();
+  case 13:
+#line 228 "../config_gram.y"
+    { current_prog = pgm_new();
       strcpy(current_prog->config_file, infile);
       current_prog->lineno = lineno;
-    ;
-    break;}
-case 11:
-#line 215 "../config_gram.y"
-{ 
+    }
+    break;
+
+  case 14:
+#line 233 "../config_gram.y"
+    { 
       if (lsize(current_prog->id) == 0) {
         fprintf(stderr,
                 "%s: error at %s:%d: required parameter id not specified\n",
@@ -1050,19 +1640,21 @@
       }
       PUSH(programmers, current_prog); 
       current_prog = NULL; 
-    ;
-    break;}
-case 12:
-#line 235 "../config_gram.y"
-{
+    }
+    break;
+
+  case 15:
+#line 253 "../config_gram.y"
+    {
       current_part = avr_new_part();
       strcpy(current_part->config_file, infile);
       current_part->lineno = lineno;
-    ;
-    break;}
-case 13:
-#line 241 "../config_gram.y"
-{ 
+    }
+    break;
+
+  case 16:
+#line 259 "../config_gram.y"
+    { 
       LNODEID ln;
       AVRMEM * m;
 
@@ -1112,27 +1704,32 @@
 
       PUSH(part_list, current_part); 
       current_part = NULL; 
-    ;
-    break;}
-case 14:
-#line 296 "../config_gram.y"
-{ ladd(string_list, yyvsp[0]); ;
-    break;}
-case 15:
-#line 297 "../config_gram.y"
-{ ladd(string_list, yyvsp[0]); ;
-    break;}
-case 16:
-#line 302 "../config_gram.y"
-{ ladd(number_list, yyvsp[0]); ;
-    break;}
-case 17:
-#line 303 "../config_gram.y"
-{ ladd(number_list, yyvsp[0]); ;
-    break;}
-case 20:
+    }
+    break;
+
+  case 17:
 #line 314 "../config_gram.y"
-{
+    { ladd(string_list, (yyvsp[0])); }
+    break;
+
+  case 18:
+#line 315 "../config_gram.y"
+    { ladd(string_list, (yyvsp[0])); }
+    break;
+
+  case 19:
+#line 320 "../config_gram.y"
+    { ladd(number_list, (yyvsp[0])); }
+    break;
+
+  case 20:
+#line 321 "../config_gram.y"
+    { ladd(number_list, (yyvsp[0])); }
+    break;
+
+  case 23:
+#line 332 "../config_gram.y"
+    {
     { 
       TOKEN * t;
       while (lsize(string_list)) {
@@ -1141,75 +1738,84 @@
         free_token(t);
       }
     }
-  ;
-    break;}
-case 21:
-#line 325 "../config_gram.y"
-{
+  }
+    break;
+
+  case 24:
+#line 343 "../config_gram.y"
+    {
     { 
       par_initpgm(current_prog);
     }
-  ;
-    break;}
-case 22:
-#line 331 "../config_gram.y"
-{
+  }
+    break;
+
+  case 25:
+#line 349 "../config_gram.y"
     {
+    {
       serbb_initpgm(current_prog);
     }
-  ;
-    break;}
-case 23:
-#line 337 "../config_gram.y"
-{
+  }
+    break;
+
+  case 26:
+#line 355 "../config_gram.y"
+    {
     { 
       stk500_initpgm(current_prog);
     }
-  ;
-    break;}
-case 24:
-#line 343 "../config_gram.y"
-{
+  }
+    break;
+
+  case 27:
+#line 361 "../config_gram.y"
     {
+    {
       stk500v2_initpgm(current_prog);
     }
-  ;
-    break;}
-case 25:
-#line 349 "../config_gram.y"
-{
+  }
+    break;
+
+  case 28:
+#line 367 "../config_gram.y"
+    {
     { 
       avr910_initpgm(current_prog);
     }
-  ;
-    break;}
-case 26:
-#line 355 "../config_gram.y"
-{
+  }
+    break;
+
+  case 29:
+#line 373 "../config_gram.y"
+    {
     { 
       butterfly_initpgm(current_prog);
     }
-  ;
-    break;}
-case 27:
-#line 361 "../config_gram.y"
-{
+  }
+    break;
+
+  case 30:
+#line 379 "../config_gram.y"
     {
+    {
       jtagmkII_initpgm(current_prog);
     }
-  ;
-    break;}
-case 28:
-#line 367 "../config_gram.y"
-{
-    strncpy(current_prog->desc, yyvsp[0]->value.string, PGM_DESCLEN);
+  }
+    break;
+
+  case 31:
+#line 385 "../config_gram.y"
+    {
+    strncpy(current_prog->desc, (yyvsp[0])->value.string, PGM_DESCLEN);
     current_prog->desc[PGM_DESCLEN-1] = 0;
-    free_token(yyvsp[0]);
-  ;
-    break;}
-case 29:
-#line 373 "../config_gram.y"
-{
+    free_token((yyvsp[0]));
+  }
+    break;
+
+  case 32:
+#line 391 "../config_gram.y"
+    {
     { 
       TOKEN * t;
       int pin;
@@ -1232,11 +1838,12 @@
         free_token(t);
       }
     }
-  ;
-    break;}
-case 30:
-#line 398 "../config_gram.y"
-{
+  }
+    break;
+
+  case 33:
+#line 416 "../config_gram.y"
+    {
     { 
       TOKEN * t;
       int pin;
@@ -1259,328 +1866,374 @@
         free_token(t);
       }
     }
-  ;
-    break;}
-case 31:
-#line 423 "../config_gram.y"
-{
+  }
+    break;
+
+  case 34:
+#line 441 "../config_gram.y"
     {
-      current_prog->baudrate = yyvsp[0]->value.number;
+    {
+      current_prog->baudrate = (yyvsp[0])->value.number;
     }
-  ;
-    break;}
-case 32:
-#line 429 "../config_gram.y"
-{ free_token(yyvsp[-2]); 
-                                  assign_pin(PIN_AVR_RESET, yyvsp[0], 0); ;
-    break;}
-case 33:
-#line 431 "../config_gram.y"
-{ free_token(yyvsp[-2]); 
-                                  assign_pin(PIN_AVR_SCK, yyvsp[0], 0); ;
-    break;}
-case 34:
-#line 433 "../config_gram.y"
-{ assign_pin(PIN_AVR_MOSI, yyvsp[0], 0); ;
-    break;}
-case 35:
-#line 434 "../config_gram.y"
-{ assign_pin(PIN_AVR_MISO, yyvsp[0], 0); ;
-    break;}
-case 36:
-#line 435 "../config_gram.y"
-{ assign_pin(PIN_LED_ERR, yyvsp[0], 0); ;
-    break;}
-case 37:
-#line 436 "../config_gram.y"
-{ assign_pin(PIN_LED_RDY, yyvsp[0], 0); ;
-    break;}
-case 38:
-#line 437 "../config_gram.y"
-{ assign_pin(PIN_LED_PGM, yyvsp[0], 0); ;
-    break;}
-case 39:
-#line 438 "../config_gram.y"
-{ assign_pin(PIN_LED_VFY, yyvsp[0], 0); ;
-    break;}
-case 40:
-#line 440 "../config_gram.y"
-{ free_token(yyvsp[-3]); 
-                                  assign_pin(PIN_AVR_RESET, yyvsp[0], 1); ;
-    break;}
-case 41:
-#line 442 "../config_gram.y"
-{ free_token(yyvsp[-3]); 
-                                  assign_pin(PIN_AVR_SCK, yyvsp[0], 1); ;
-    break;}
-case 42:
-#line 444 "../config_gram.y"
-{ assign_pin(PIN_AVR_MOSI, yyvsp[0], 1); ;
-    break;}
-case 43:
-#line 445 "../config_gram.y"
-{ assign_pin(PIN_AVR_MISO, yyvsp[0], 1); ;
-    break;}
-case 44:
-#line 446 "../config_gram.y"
-{ assign_pin(PIN_LED_ERR, yyvsp[0], 1); ;
-    break;}
-case 45:
+  }
+    break;
+
+  case 35:
 #line 447 "../config_gram.y"
-{ assign_pin(PIN_LED_RDY, yyvsp[0], 1); ;
-    break;}
-case 46:
-#line 448 "../config_gram.y"
-{ assign_pin(PIN_LED_PGM, yyvsp[0], 1); ;
-    break;}
-case 47:
+    { free_token((yyvsp[-2])); 
+                                  assign_pin(PIN_AVR_RESET, (yyvsp[0]), 0); }
+    break;
+
+  case 36:
 #line 449 "../config_gram.y"
-{ assign_pin(PIN_LED_VFY, yyvsp[0], 1); ;
-    break;}
-case 67:
-#line 488 "../config_gram.y"
-{
-      strncpy(current_part->id, yyvsp[0]->value.string, AVR_IDLEN);
+    { free_token((yyvsp[-2])); 
+                                  assign_pin(PIN_AVR_SCK, (yyvsp[0]), 0); }
+    break;
+
+  case 37:
+#line 451 "../config_gram.y"
+    { assign_pin(PIN_AVR_MOSI, (yyvsp[0]), 0); }
+    break;
+
+  case 38:
+#line 452 "../config_gram.y"
+    { assign_pin(PIN_AVR_MISO, (yyvsp[0]), 0); }
+    break;
+
+  case 39:
+#line 453 "../config_gram.y"
+    { assign_pin(PIN_LED_ERR, (yyvsp[0]), 0); }
+    break;
+
+  case 40:
+#line 454 "../config_gram.y"
+    { assign_pin(PIN_LED_RDY, (yyvsp[0]), 0); }
+    break;
+
+  case 41:
+#line 455 "../config_gram.y"
+    { assign_pin(PIN_LED_PGM, (yyvsp[0]), 0); }
+    break;
+
+  case 42:
+#line 456 "../config_gram.y"
+    { assign_pin(PIN_LED_VFY, (yyvsp[0]), 0); }
+    break;
+
+  case 43:
+#line 458 "../config_gram.y"
+    { free_token((yyvsp[-3])); 
+                                  assign_pin(PIN_AVR_RESET, (yyvsp[0]), 1); }
+    break;
+
+  case 44:
+#line 460 "../config_gram.y"
+    { free_token((yyvsp[-3])); 
+                                  assign_pin(PIN_AVR_SCK, (yyvsp[0]), 1); }
+    break;
+
+  case 45:
+#line 462 "../config_gram.y"
+    { assign_pin(PIN_AVR_MOSI, (yyvsp[0]), 1); }
+    break;
+
+  case 46:
+#line 463 "../config_gram.y"
+    { assign_pin(PIN_AVR_MISO, (yyvsp[0]), 1); }
+    break;
+
+  case 47:
+#line 464 "../config_gram.y"
+    { assign_pin(PIN_LED_ERR, (yyvsp[0]), 1); }
+    break;
+
+  case 48:
+#line 465 "../config_gram.y"
+    { assign_pin(PIN_LED_RDY, (yyvsp[0]), 1); }
+    break;
+
+  case 49:
+#line 466 "../config_gram.y"
+    { assign_pin(PIN_LED_PGM, (yyvsp[0]), 1); }
+    break;
+
+  case 50:
+#line 467 "../config_gram.y"
+    { assign_pin(PIN_LED_VFY, (yyvsp[0]), 1); }
+    break;
+
+  case 70:
+#line 506 "../config_gram.y"
+    {
+      strncpy(current_part->id, (yyvsp[0])->value.string, AVR_IDLEN);
       current_part->id[AVR_IDLEN-1] = 0;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 68:
-#line 495 "../config_gram.y"
-{
-      strncpy(current_part->desc, yyvsp[0]->value.string, AVR_DESCLEN);
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 71:
+#line 513 "../config_gram.y"
+    {
+      strncpy(current_part->desc, (yyvsp[0])->value.string, AVR_DESCLEN);
       current_part->desc[AVR_DESCLEN-1] = 0;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 69:
-#line 501 "../config_gram.y"
-{
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 72:
+#line 519 "../config_gram.y"
     {
+    {
       fprintf(stderr, 
               "%s: error at %s:%d: devicecode is deprecated, use "
               "stk500_devcode instead\n",
               progname, infile, lineno);
       exit(1);
     }
-  ;
-    break;}
-case 70:
-#line 511 "../config_gram.y"
-{
+  }
+    break;
+
+  case 73:
+#line 529 "../config_gram.y"
     {
-      current_part->stk500_devcode = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
+    {
+      current_part->stk500_devcode = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
     }
-  ;
-    break;}
-case 71:
-#line 518 "../config_gram.y"
-{
+  }
+    break;
+
+  case 74:
+#line 536 "../config_gram.y"
     {
-      current_part->avr910_devcode = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
+    {
+      current_part->avr910_devcode = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
     }
-  ;
-    break;}
-case 72:
-#line 526 "../config_gram.y"
-{
-      current_part->chip_erase_delay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 73:
-#line 532 "../config_gram.y"
-{
-      current_part->pagel = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 74:
-#line 538 "../config_gram.y"
-{
-      current_part->bs2 = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 75:
+  }
+    break;
+
+  case 75:
 #line 544 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_DEDICATED)
+    {
+      current_part->chip_erase_delay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 76:
+#line 550 "../config_gram.y"
+    {
+      current_part->pagel = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 77:
+#line 556 "../config_gram.y"
+    {
+      current_part->bs2 = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 78:
+#line 562 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_DEDICATED)
         current_part->reset_disposition = RESET_DEDICATED;
-      else if (yyvsp[0]->primary == K_IO)
+      else if ((yyvsp[0])->primary == K_IO)
         current_part->reset_disposition = RESET_IO;
 
-      free_tokens(2, yyvsp[-2], yyvsp[0]);
-    ;
-    break;}
-case 76:
-#line 554 "../config_gram.y"
-{
-      current_part->timeout = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 77:
-#line 560 "../config_gram.y"
-{
-      current_part->stabdelay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 78:
-#line 566 "../config_gram.y"
-{
-      current_part->cmdexedelay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 79:
+      free_tokens(2, (yyvsp[-2]), (yyvsp[0]));
+    }
+    break;
+
+  case 79:
 #line 572 "../config_gram.y"
-{
-      current_part->synchloops = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 80:
+    {
+      current_part->timeout = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 80:
 #line 578 "../config_gram.y"
-{
-      current_part->bytedelay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 81:
+    {
+      current_part->stabdelay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 81:
 #line 584 "../config_gram.y"
-{
-      current_part->pollvalue = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 82:
+    {
+      current_part->cmdexedelay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 82:
 #line 590 "../config_gram.y"
-{
-      current_part->pollindex = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 83:
+    {
+      current_part->synchloops = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 83:
 #line 596 "../config_gram.y"
-{
-      current_part->predelay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 84:
+    {
+      current_part->bytedelay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 84:
 #line 602 "../config_gram.y"
-{
-      current_part->postdelay = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 85:
+    {
+      current_part->pollvalue = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 85:
 #line 608 "../config_gram.y"
-{
-      current_part->pollmethod = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 86:
+    {
+      current_part->pollindex = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 86:
 #line 614 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_YES)
+    {
+      current_part->predelay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 87:
+#line 620 "../config_gram.y"
+    {
+      current_part->postdelay = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 88:
+#line 626 "../config_gram.y"
+    {
+      current_part->pollmethod = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 89:
+#line 632 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_YES)
         current_part->flags |= AVRPART_HAS_JTAG;
-      else if (yyvsp[0]->primary == K_NO)
+      else if ((yyvsp[0])->primary == K_NO)
         current_part->flags &= ~AVRPART_HAS_JTAG;
 
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 87:
-#line 624 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_YES)
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 90:
+#line 642 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_YES)
         current_part->flags |= AVRPART_ALLOWFULLPAGEBITSTREAM;
-      else if (yyvsp[0]->primary == K_NO)
+      else if ((yyvsp[0])->primary == K_NO)
         current_part->flags &= ~AVRPART_ALLOWFULLPAGEBITSTREAM;
 
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 88:
-#line 634 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_YES)
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 91:
+#line 652 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_YES)
         current_part->flags |= AVRPART_ENABLEPAGEPROGRAMMING;
-      else if (yyvsp[0]->primary == K_NO)
+      else if ((yyvsp[0])->primary == K_NO)
         current_part->flags &= ~AVRPART_ENABLEPAGEPROGRAMMING;
 
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 89:
-#line 644 "../config_gram.y"
-{
-      current_part->idr = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 90:
-#line 650 "../config_gram.y"
-{
-      current_part->rampz = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 91:
-#line 656 "../config_gram.y"
-{
-      current_part->spmcr = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 92:
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 92:
 #line 662 "../config_gram.y"
-{
-      current_part->eecr = yyvsp[0]->value.number;
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 93:
+    {
+      current_part->idr = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 93:
 #line 668 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_YES)
+    {
+      current_part->rampz = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 94:
+#line 674 "../config_gram.y"
+    {
+      current_part->spmcr = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 95:
+#line 680 "../config_gram.y"
+    {
+      current_part->eecr = (yyvsp[0])->value.number;
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 96:
+#line 686 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_YES)
         current_part->flags |= AVRPART_SERIALOK;
-      else if (yyvsp[0]->primary == K_NO)
+      else if ((yyvsp[0])->primary == K_NO)
         current_part->flags &= ~AVRPART_SERIALOK;
 
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 94:
-#line 678 "../config_gram.y"
-{
-      if (yyvsp[0]->primary == K_YES) {
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 97:
+#line 696 "../config_gram.y"
+    {
+      if ((yyvsp[0])->primary == K_YES) {
         current_part->flags |= AVRPART_PARALLELOK;
         current_part->flags &= ~AVRPART_PSEUDOPARALLEL;
       }
-      else if (yyvsp[0]->primary == K_NO) {
+      else if ((yyvsp[0])->primary == K_NO) {
         current_part->flags &= ~AVRPART_PARALLELOK;
         current_part->flags &= ~AVRPART_PSEUDOPARALLEL;
       }
-      else if (yyvsp[0]->primary == K_PSEUDO) {
+      else if ((yyvsp[0])->primary == K_PSEUDO) {
         current_part->flags |= AVRPART_PARALLELOK;
         current_part->flags |= AVRPART_PSEUDOPARALLEL;
       }
 
 
-      free_token(yyvsp[0]);
-    ;
-    break;}
-case 95:
-#line 697 "../config_gram.y"
-{
-      switch (yyvsp[0]->primary) {
+      free_token((yyvsp[0]));
+    }
+    break;
+
+  case 98:
+#line 715 "../config_gram.y"
+    {
+      switch ((yyvsp[0])->primary) {
         case K_RESET :
           current_part->retry_pulse = PIN_AVR_RESET;
           break;
